#include <stdio.h>
#include <stdlib.h>

#include "snmp_acs.h"

int main(int argc,char *argv[])
{
  LOCAL_MIB_ACCESS Mib;
  BOOL ret;
  DWORD dwTimeZeroReference;
  HANDLE PollForTrapEvent;
  AsnObjectIdentifier SupportedView[32];
  int                 SupportedViewCount;
  RFC1157VarBindList  *varBindList;
  RFC1157VarBind      varBind[5];
  AsnInteger          errorStatus;
  AsnInteger          errorIndex;
  RFC1157VarBindList  BindList;

  AsnObjectIdentifier MIB_NULL = {0,0};


  UINT OID_udpLocalAddress[] = { 1, 3, 6, 1, 2, 1, 7, 5, 1, 1};
  AsnObjectIdentifier MIB_udpLocalAddress = { OID_SIZEOF(OID_udpLocalAddress), OID_udpLocalAddress };
  
  UINT OID_udpLocalPort[] = { 1, 3, 6, 1, 2, 1, 7, 5, 1, 2};
  AsnObjectIdentifier MIB_udpLocalPort = { OID_SIZEOF(OID_udpLocalPort), OID_udpLocalPort };

  UINT OID_tcpConnState[] =             { 1, 3, 6, 1, 2, 1, 6, 13, 1, 1};
  AsnObjectIdentifier MIB_tcpConnState = { OID_SIZEOF(OID_tcpConnState), OID_tcpConnState };
  
  UINT OID_tcpConnLocalAddress[] =      { 1, 3, 6, 1, 2, 1, 6, 13, 1, 2};
  AsnObjectIdentifier MIB_tcpConnLocalAddress = { OID_SIZEOF(OID_tcpConnLocalAddress), OID_tcpConnLocalAddress };
  
  UINT OID_tcpConnLocalPort[] =         { 1, 3, 6, 1, 2, 1, 6, 13, 1, 3};
  AsnObjectIdentifier MIB_tcpConnLocalPort = { OID_SIZEOF(OID_tcpConnLocalPort), OID_tcpConnLocalPort };
  
  UINT OID_tcpConnRemAddress[] =        { 1, 3, 6, 1, 2, 1, 6, 13, 1, 4};
  AsnObjectIdentifier MIB_tcpConnRemAddress = { OID_SIZEOF(OID_tcpConnRemAddress), OID_tcpConnRemAddress };
  
  UINT OID_tcpConnRemPort[] =           { 1, 3, 6, 1, 2, 1, 6, 13, 1, 5};
  AsnObjectIdentifier MIB_tcpConnRemPort = { OID_SIZEOF(OID_tcpConnRemPort), OID_tcpConnRemPort };

  char *tcpStateName[] = {
                          "closed(1)",
                          "listen(2)",
                          "synSent(3)",
                          "synReceived(4)",
                          "established(5)",
                          "finWait1(6)",
                          "finWait2(7)",
                          "closeWait(8)",
                          "lastAck(9)",
                          "closing(10)",
                          "timeWait(11)",
                          "deleteTCB(12)"
                        };
  

  WSADATA wsa;
  BOOL Exit;
  int  i;
  DWORD dtmp,dtmp1;
  
  varBindList = &BindList;

  ret = WSAStartup( 0x0101, &wsa );  

  ret = OpenMib("inetmib1.dll",&Mib);
  if(!ret){
    printf("\nCan't find INETMIB1.DLL");
    return -1;
  }


  dwTimeZeroReference = GetTickCount();
  SupportedView[0] = MIB_NULL;

  SupportedViewCount = 0;

  dwTimeZeroReference = 0;
  ret = Mib.m_Init(dwTimeZeroReference,&PollForTrapEvent,&SupportedView[0]);
  SupportedViewCount = 1;

  if(!ret){
    printf("\nInit Fail");
    return -1;
  }


  // show UDP active sockets
  printf("\n UDP active sockets:");
  
  varBindList->list = varBind;
  varBindList->len  = 2;
  varBind[0].name  = MIB_NULL;
  varBind[1].name  = MIB_NULL;

  SNMP_oidcpy(&varBind[0].name,&MIB_udpLocalAddress);
  SNMP_oidcpy(&varBind[1].name,&MIB_udpLocalPort);

  Exit = FALSE;
  i = 0;
  while(!Exit){
    ret = Mib.m_Query(ASN_RFC1157_GETNEXTREQUEST,varBindList,&errorStatus,&errorIndex);
    if(!ret)
      Exit=TRUE;
    else{
      ret = SNMP_oidncmp(&varBind[0].name,&MIB_udpLocalAddress,MIB_udpLocalAddress.idLength);
      if(ret!=0){
        Exit=TRUE;
      }
      else{
        i++;
        dtmp = *(DWORD *)varBind[0].value.asnValue.address.stream;
        dtmp1 = varBind[1].value.asnValue.number;
        printf("\n %2d Ip %s Port %d",
          i,inet_ntoa(*(struct in_addr *)&dtmp),dtmp1);
      }
    }

  }

  SNMP_FreeVarBind(&varBind[0]);
  SNMP_FreeVarBind(&varBind[1]);

  // show TCP active sockets
  printf("\n TCP active sockets:");

  varBindList->list = varBind;
  varBindList->len  = 5;
  varBind[0].name  = MIB_NULL;
  varBind[1].name  = MIB_NULL;
  varBind[2].name  = MIB_NULL;
  varBind[3].name  = MIB_NULL;
  varBind[4].name  = MIB_NULL;

  SNMP_oidcpy(&varBind[0].name,&MIB_tcpConnState);
  SNMP_oidcpy(&varBind[1].name,&MIB_tcpConnLocalAddress);
  SNMP_oidcpy(&varBind[2].name,&MIB_tcpConnLocalPort);
  SNMP_oidcpy(&varBind[3].name,&MIB_tcpConnRemAddress);
  SNMP_oidcpy(&varBind[4].name,&MIB_tcpConnRemPort);

  Exit = FALSE;
  i = 0;
  while(!Exit){
    ret = Mib.m_Query(ASN_RFC1157_GETNEXTREQUEST,varBindList,&errorStatus,&errorIndex);
    if(!ret)
      Exit=TRUE;
    else{
      ret = SNMP_oidncmp(&varBind[0].name,&MIB_tcpConnState,MIB_tcpConnState.idLength);
      if(ret!=0){
        Exit=TRUE;
      }
      else{
        i++;
        dtmp = *(DWORD *)varBind[1].value.asnValue.address.stream;
        printf("\n %2d LocalIp %15s : %3d <-->",
          i,inet_ntoa(*(struct in_addr *)&dtmp),
          varBind[2].value.asnValue.number);
        dtmp = *(DWORD *)varBind[3].value.asnValue.address.stream;
        dtmp1 = varBind[0].value.asnValue.number-1;
        printf(" %15s : %3d Status %s",
          inet_ntoa(*(struct in_addr *)&dtmp),
          varBind[4].value.asnValue.number,
          tcpStateName[dtmp1]);
      }
    }

  }

  SNMP_FreeVarBind(&varBind[0]);
  SNMP_FreeVarBind(&varBind[1]);
  SNMP_FreeVarBind(&varBind[2]);
  SNMP_FreeVarBind(&varBind[3]);
  SNMP_FreeVarBind(&varBind[4]);

  CloseMib(&Mib);
  WSACleanup();

  return 0;
}