#include <stdio.h>
#include "snmp_acs.h"

BOOL OpenMib(char *Name,LOCAL_MIB_ACCESS *Mib)
{
  Mib->m_hInst = LoadLibrary( Name );
  if(Mib->m_hInst < (HINSTANCE) HINSTANCE_ERROR){
    return FALSE;
  }

  Mib->m_Init=(pSnmpExtensionInit)GetProcAddress(Mib->m_hInst ,"SnmpExtensionInit");
  if(Mib->m_Init==NULL){
    CloseMib( Mib );
    return FALSE;
  }

  Mib->m_InitEx=(pSnmpExtensionInitEx)GetProcAddress(Mib->m_hInst ,"SnmpExtensionInitEx");
  if(Mib->m_InitEx==NULL){
    CloseMib( Mib );
    return FALSE;
  }

  Mib->m_Query=(pSnmpExtensionQuery)GetProcAddress(Mib->m_hInst ,"SnmpExtensionQuery");
  if(Mib->m_Query==NULL){
    CloseMib( Mib );
    return FALSE;
  }

  Mib->m_Trap=(pSnmpExtensionTrap)GetProcAddress(Mib->m_hInst ,"SnmpExtensionTrap");
  if(Mib->m_Trap==NULL){
    CloseMib( Mib );
    return FALSE;
  }

  return TRUE;
}

void CloseMib(LOCAL_MIB_ACCESS *Mib)
{
  FreeLibrary( Mib->m_hInst );
}

void  SNMP_printname(AsnObjectName *name)
{
  int i;

  for(i=0;i<name->idLength;i++){
    if(i!=0)
      printf(".");
    printf("%d",name->ids[i]);
  }
}

