#ifndef _SNMP_ACCESS_H_
#define _SNMP_ACCESS_H_

#include <snmp.h>

typedef BOOL (WINAPI *pSnmpExtensionInit)(
    IN  DWORD               dwTimeZeroReference,
    OUT HANDLE              *hPollForTrapEvent,
    OUT AsnObjectIdentifier *supportedView);

typedef BOOL (WINAPI *pSnmpExtensionTrap)(
    OUT AsnObjectIdentifier *enterprise,
    OUT AsnInteger          *genericTrap,
    OUT AsnInteger          *specificTrap,
    OUT AsnTimeticks        *timeStamp,
    OUT RFC1157VarBindList  *variableBindings);

typedef BOOL (WINAPI *pSnmpExtensionQuery)(
    IN BYTE                   requestType,
    IN OUT RFC1157VarBindList *variableBindings,
    OUT AsnInteger            *errorStatus,
    OUT AsnInteger            *errorIndex);

typedef BOOL (WINAPI *pSnmpExtensionInitEx)(
    OUT AsnObjectIdentifier *supportedView);


typedef struct {
  HINSTANCE             m_hInst;
  pSnmpExtensionInit    m_Init;
  pSnmpExtensionInitEx  m_InitEx;
  pSnmpExtensionQuery   m_Query;
  pSnmpExtensionTrap    m_Trap;
} LOCAL_MIB_ACCESS;

#define OID_SIZEOF( Oid )      ( sizeof Oid / sizeof(UINT) )

#ifdef __cplusplus
extern "C" {
#endif

BOOL OpenMib(char *Name,LOCAL_MIB_ACCESS *Mib);
void CloseMib(LOCAL_MIB_ACCESS *Mib);

void  SNMP_printname(AsnObjectName *name);

#ifdef __cplusplus
}
#endif

#endif